import { Injectable } from '@angular/core';
import { MessageService } from './message.service';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { UserCreds } from './userCreds'
import { ThrowStmt } from '@angular/compiler';
@Injectable({
  providedIn: 'root'
})
export class TokenService {

  public static Id_Token_Key : string = "id_token";

  constructor(private http: HttpClient, private messageService: MessageService) {
    this.messageService.add("TokenService started, token created")

    if (! localStorage.getItem(TokenService.Id_Token_Key)) {
      localStorage.setItem(TokenService.Id_Token_Key, "abc")
      this.messageService.add("Token set in local storage")
    }
  }


  async login(login: string, password: string) {
    this.messageService.add(`TokenService: trying to login and obtain token`);
    const userCreds : UserCreds = {
      "application": "hv2",
      "login": login,
      "password": password
    }
    const token = await this.http.post(
      "https://authservice.hottis.de/token", 
      userCreds,
      {responseType:'text'}
    ).toPromise()
    this.messageService.add(`Token is ${token}`)
    localStorage.setItem(TokenService.Id_Token_Key, token)
    this.messageService.add("Token saved")
  }

}
